# coding: utf-8

"""
    NewsCatcher-V3 Production API

    <img src='https://uploads-ssl.webflow.com/6429857b17973b636c2195c5/646c6f1eb774ff2f2997bec5_newscatcher_.svg' width='286' height='35' /> <br>  <br>Visit our website  <a href='https://newscatcherapi.com'>https://newscatcherapi.com</a>

    The version of the OpenAPI document: 3.2.16
    Contact: maksym@newscatcherapi.com
    Generated by: https://konfigthis.com
"""

from dataclasses import dataclass
import typing_extensions
import urllib3
from pydantic import RootModel
from newscatcherapi_client.request_before_hook import request_before_hook
import json
from urllib3._collections import HTTPHeaderDict

from newscatcherapi_client.api_response import AsyncGeneratorResponse
from newscatcherapi_client import api_client, exceptions
from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from newscatcherapi_client import schemas  # noqa: F401

from newscatcherapi_client.model.source_response import SourceResponse as SourceResponseSchema
from newscatcherapi_client.model.http_validation_error import HTTPValidationError as HTTPValidationErrorSchema

from newscatcherapi_client.type.source_response import SourceResponse
from newscatcherapi_client.type.http_validation_error import HTTPValidationError

from ...api_client import Dictionary
from newscatcherapi_client.pydantic.source_response import SourceResponse as SourceResponsePydantic
from newscatcherapi_client.pydantic.http_validation_error import HTTPValidationError as HTTPValidationErrorPydantic

from . import path

# Query params
LangSchema = schemas.AnyTypeSchema
CountriesSchema = schemas.AnyTypeSchema
PredefinedSourcesSchema = schemas.AnyTypeSchema
IncludeAdditionalInfoSchema = schemas.BoolSchema
FromRankSchema = schemas.IntSchema
ToRankSchema = schemas.IntSchema
SourceNameSchema = schemas.AnyTypeSchema
SourceUrlSchema = schemas.AnyTypeSchema
IsNewsDomainSchema = schemas.BoolSchema
NewsDomainTypeSchema = schemas.AnyTypeSchema
NewsTypeSchema = schemas.AnyTypeSchema
RequestRequiredQueryParams = typing_extensions.TypedDict(
    'RequestRequiredQueryParams',
    {
    }
)
RequestOptionalQueryParams = typing_extensions.TypedDict(
    'RequestOptionalQueryParams',
    {
        'lang': typing.Union[LangSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'countries': typing.Union[CountriesSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'predefined_sources': typing.Union[PredefinedSourcesSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'include_additional_info': typing.Union[IncludeAdditionalInfoSchema, bool, ],
        'from_rank': typing.Union[FromRankSchema, decimal.Decimal, int, ],
        'to_rank': typing.Union[ToRankSchema, decimal.Decimal, int, ],
        'source_name': typing.Union[SourceNameSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'source_url': typing.Union[SourceUrlSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'is_news_domain': typing.Union[IsNewsDomainSchema, bool, ],
        'news_domain_type': typing.Union[NewsDomainTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        'news_type': typing.Union[NewsTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
    },
    total=False
)


class RequestQueryParams(RequestRequiredQueryParams, RequestOptionalQueryParams):
    pass


request_query_lang = api_client.QueryParameter(
    name="lang",
    style=api_client.ParameterStyle.FORM,
    schema=LangSchema,
    explode=True,
)
request_query_countries = api_client.QueryParameter(
    name="countries",
    style=api_client.ParameterStyle.FORM,
    schema=CountriesSchema,
    explode=True,
)
request_query_predefined_sources = api_client.QueryParameter(
    name="predefined_sources",
    style=api_client.ParameterStyle.FORM,
    schema=PredefinedSourcesSchema,
    explode=True,
)
request_query_include_additional_info = api_client.QueryParameter(
    name="include_additional_info",
    style=api_client.ParameterStyle.FORM,
    schema=IncludeAdditionalInfoSchema,
    explode=True,
)
request_query_from_rank = api_client.QueryParameter(
    name="from_rank",
    style=api_client.ParameterStyle.FORM,
    schema=FromRankSchema,
    explode=True,
)
request_query_to_rank = api_client.QueryParameter(
    name="to_rank",
    style=api_client.ParameterStyle.FORM,
    schema=ToRankSchema,
    explode=True,
)
request_query_source_name = api_client.QueryParameter(
    name="source_name",
    style=api_client.ParameterStyle.FORM,
    schema=SourceNameSchema,
    explode=True,
)
request_query_source_url = api_client.QueryParameter(
    name="source_url",
    style=api_client.ParameterStyle.FORM,
    schema=SourceUrlSchema,
    explode=True,
)
request_query_is_news_domain = api_client.QueryParameter(
    name="is_news_domain",
    style=api_client.ParameterStyle.FORM,
    schema=IsNewsDomainSchema,
    explode=True,
)
request_query_news_domain_type = api_client.QueryParameter(
    name="news_domain_type",
    style=api_client.ParameterStyle.FORM,
    schema=NewsDomainTypeSchema,
    explode=True,
)
request_query_news_type = api_client.QueryParameter(
    name="news_type",
    style=api_client.ParameterStyle.FORM,
    schema=NewsTypeSchema,
    explode=True,
)
_auth = [
    'apiKey',
]
SchemaFor200ResponseBodyApplicationJson = SourceResponseSchema


@dataclass
class ApiResponseFor200(api_client.ApiResponse):
    body: SourceResponse


@dataclass
class ApiResponseFor200Async(api_client.AsyncApiResponse):
    body: SourceResponse


_response_for_200 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor200,
    response_cls_async=ApiResponseFor200Async,
    content={
        'application/json': api_client.MediaType(
            schema=SchemaFor200ResponseBodyApplicationJson),
    },
)
SchemaFor422ResponseBodyApplicationJson = HTTPValidationErrorSchema


@dataclass
class ApiResponseFor422(api_client.ApiResponse):
    body: HTTPValidationError


@dataclass
class ApiResponseFor422Async(api_client.AsyncApiResponse):
    body: HTTPValidationError


_response_for_422 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor422,
    response_cls_async=ApiResponseFor422Async,
    content={
        'application/json': api_client.MediaType(
            schema=SchemaFor422ResponseBodyApplicationJson),
    },
)
_status_code_to_response = {
    '200': _response_for_200,
    '422': _response_for_422,
}
_all_accept_content_types = (
    'application/json',
)


class BaseApi(api_client.Api):

    def _get_mapped_args(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
    ) -> api_client.MappedArgs:
        args: api_client.MappedArgs = api_client.MappedArgs()
        _query_params = {}
        if lang is not None:
            _query_params["lang"] = lang
        if countries is not None:
            _query_params["countries"] = countries
        if predefined_sources is not None:
            _query_params["predefined_sources"] = predefined_sources
        if include_additional_info is not None:
            _query_params["include_additional_info"] = include_additional_info
        if from_rank is not None:
            _query_params["from_rank"] = from_rank
        if to_rank is not None:
            _query_params["to_rank"] = to_rank
        if source_name is not None:
            _query_params["source_name"] = source_name
        if source_url is not None:
            _query_params["source_url"] = source_url
        if is_news_domain is not None:
            _query_params["is_news_domain"] = is_news_domain
        if news_domain_type is not None:
            _query_params["news_domain_type"] = news_domain_type
        if news_type is not None:
            _query_params["news_type"] = news_type
        args.query = _query_params
        return args

    async def _aget_oapg(
        self,
            query_params: typing.Optional[dict] = {},
        skip_deserialization: bool = True,
        timeout: typing.Optional[typing.Union[float, typing.Tuple]] = None,
        accept_content_types: typing.Tuple[str] = _all_accept_content_types,
        stream: bool = False,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        """
        [Get] Search For Sources Request
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        self._verify_typed_dict_inputs_oapg(RequestQueryParams, query_params)
        used_path = path.value
    
        prefix_separator_iterator = None
        for parameter in (
            request_query_lang,
            request_query_countries,
            request_query_predefined_sources,
            request_query_include_additional_info,
            request_query_from_rank,
            request_query_to_rank,
            request_query_source_name,
            request_query_source_url,
            request_query_is_news_domain,
            request_query_news_domain_type,
            request_query_news_type,
        ):
            parameter_data = query_params.get(parameter.name, schemas.unset)
            if parameter_data is schemas.unset:
                continue
            if prefix_separator_iterator is None:
                prefix_separator_iterator = parameter.get_prefix_separator_iterator()
            serialized_data = parameter.serialize(parameter_data, prefix_separator_iterator)
            for serialized_value in serialized_data.values():
                used_path += serialized_value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        if accept_content_types:
            for accept_content_type in accept_content_types:
                _headers.add('Accept', accept_content_type)
        method = 'get'.upper()
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            path_template='/api/sources',
            auth_settings=_auth,
            headers=_headers,
        )
    
        response = await self.api_client.async_call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            auth_settings=_auth,
            prefix_separator_iterator=prefix_separator_iterator,
            timeout=timeout,
            **kwargs
        )
    
        if stream:
            if not 200 <= response.http_response.status <= 299:
                body = (await response.http_response.content.read()).decode("utf-8")
                raise exceptions.ApiStreamingException(
                    status=response.http_response.status,
                    reason=response.http_response.reason,
                    body=body,
                )
    
            async def stream_iterator():
                """
                iterates over response.http_response.content and closes connection once iteration has finished
                """
                async for line in response.http_response.content:
                    if line == b'\r\n':
                        continue
                    yield line
                response.http_response.close()
                await response.session.close()
            return AsyncGeneratorResponse(
                content=stream_iterator(),
                headers=response.http_response.headers,
                status=response.http_response.status,
                response=response.http_response
            )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = await response_for_status.deserialize_async(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserializationAsync(
                body=await response.http_response.json() if is_json else await response.http_response.text(),
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        # cleanup session / response
        response.http_response.close()
        await response.session.close()
    
        return api_response


    def _get_oapg(
        self,
            query_params: typing.Optional[dict] = {},
        skip_deserialization: bool = True,
        timeout: typing.Optional[typing.Union[float, typing.Tuple]] = None,
        accept_content_types: typing.Tuple[str] = _all_accept_content_types,
        stream: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """
        [Get] Search For Sources Request
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        self._verify_typed_dict_inputs_oapg(RequestQueryParams, query_params)
        used_path = path.value
    
        prefix_separator_iterator = None
        for parameter in (
            request_query_lang,
            request_query_countries,
            request_query_predefined_sources,
            request_query_include_additional_info,
            request_query_from_rank,
            request_query_to_rank,
            request_query_source_name,
            request_query_source_url,
            request_query_is_news_domain,
            request_query_news_domain_type,
            request_query_news_type,
        ):
            parameter_data = query_params.get(parameter.name, schemas.unset)
            if parameter_data is schemas.unset:
                continue
            if prefix_separator_iterator is None:
                prefix_separator_iterator = parameter.get_prefix_separator_iterator()
            serialized_data = parameter.serialize(parameter_data, prefix_separator_iterator)
            for serialized_value in serialized_data.values():
                used_path += serialized_value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        if accept_content_types:
            for accept_content_type in accept_content_types:
                _headers.add('Accept', accept_content_type)
        method = 'get'.upper()
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            path_template='/api/sources',
            auth_settings=_auth,
            headers=_headers,
        )
    
        response = self.api_client.call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            auth_settings=_auth,
            prefix_separator_iterator=prefix_separator_iterator,
            timeout=timeout,
        )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = response_for_status.deserialize(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserialization(
                body=json.loads(response.http_response.data) if is_json else response.http_response.data,
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        return api_response


class GetRaw(BaseApi):
    # this class is used by api classes that refer to endpoints with operationId fn names

    async def aget(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._get_mapped_args(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
        )
        return await self._aget_oapg(
            query_params=args.query,
            **kwargs,
        )
    
    def get(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """ This endpoint allows you to get the list of sources that are available in the database. You can filter the sources by language and country. The maximum number of sources displayed is set according to your plan. You can find the list of plans and their features here: https://newscatcherapi.com/news-api#news-api-pricing """
        args = self._get_mapped_args(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
        )
        return self._get_oapg(
            query_params=args.query,
        )

class Get(BaseApi):

    async def aget(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        validate: bool = False,
        **kwargs,
    ) -> SourceResponsePydantic:
        raw_response = await self.raw.aget(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
            **kwargs,
        )
        if validate:
            return SourceResponsePydantic(**raw_response.body)
        return api_client.construct_model_instance(SourceResponsePydantic, raw_response.body)
    
    
    def get(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        validate: bool = False,
    ) -> SourceResponsePydantic:
        raw_response = self.raw.get(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
        )
        if validate:
            return SourceResponsePydantic(**raw_response.body)
        return api_client.construct_model_instance(SourceResponsePydantic, raw_response.body)


class ApiForget(BaseApi):
    # this class is used by api classes that refer to endpoints by path and http method names

    async def aget(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._get_mapped_args(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
        )
        return await self._aget_oapg(
            query_params=args.query,
            **kwargs,
        )
    
    def get(
        self,
        lang: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        countries: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        predefined_sources: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        include_additional_info: typing.Optional[bool] = None,
        from_rank: typing.Optional[int] = None,
        to_rank: typing.Optional[int] = None,
        source_name: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        source_url: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        is_news_domain: typing.Optional[bool] = None,
        news_domain_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
        news_type: typing.Optional[typing.Union[bool, date, datetime, dict, float, int, list, str, None]] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """ This endpoint allows you to get the list of sources that are available in the database. You can filter the sources by language and country. The maximum number of sources displayed is set according to your plan. You can find the list of plans and their features here: https://newscatcherapi.com/news-api#news-api-pricing """
        args = self._get_mapped_args(
            lang=lang,
            countries=countries,
            predefined_sources=predefined_sources,
            include_additional_info=include_additional_info,
            from_rank=from_rank,
            to_rank=to_rank,
            source_name=source_name,
            source_url=source_url,
            is_news_domain=is_news_domain,
            news_domain_type=news_domain_type,
            news_type=news_type,
        )
        return self._get_oapg(
            query_params=args.query,
        )

